unit UnApresentacao;

interface

uses
  Windows,  Variants, Classes, Graphics, Controls, Forms, SysUtils,
  Dialogs, Menus, ComCtrls, StdCtrls, Grids, DBGrids, ExtCtrls,
  UnConexao, UnClasseUsuario, UnConst, DBClient, DB, Mask, MaskEditHV, DBCtrls;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    DataSource1: TDataSource;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    Arrangeicons1: TMenuItem;
    Utilitrios1: TMenuItem;
    Calculadora1: TMenuItem;
    Sobre1: TMenuItem;
    SobreoPrograma1: TMenuItem;
    Panel5: TPanel;
    Button6: TButton;
    Button7: TButton;
    Button9: TButton;
    Panel6: TPanel;
    DBGrid1: TDBGrid;
    Panel7: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    cbSelecionaBD: TComboBox;
    Label3: TLabel;
    Button1: TButton;
    mskNome: TMaskEditHV;
    mskDataNascimento: TMaskEditHV;
    mskEndereco: TMaskEditHV;
    mskEstado: TMaskEditHV;
    mskCidade: TMaskEditHV;
    mskCEP: TMaskEditHV;
    mskCargo: TMaskEditHV;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    mskSetor: TMaskEditHV;
    mskTelefone: TMaskEditHV;
    Label11: TLabel;
    Label12: TLabel;
    DBImage1: TDBImage;
    Button2: TButton;
    Label13: TLabel;
    mskCarregaNomes: TMaskEditHV;
    Bevel1: TBevel;
    mskSalario: TMaskEditHV;
    mskMatricula: TMaskEditHV;
    Label14: TLabel;
    Label15: TLabel;
    ClUsuario: TClientDataSet;
    ClUsuarioCd_Usuario: TIntegerField;
    ClUsuarioNome: TStringField;
    ClUsuarioDataNascimento: TDateField;
    ClUsuarioEndereco: TStringField;
    ClUsuarioCidade: TStringField;
    ClUsuarioEstado: TStringField;
    ClUsuarioCEP: TStringField;
    ClUsuarioCargo: TStringField;
    ClUsuarioSetor: TStringField;
    ClUsuarioTelefone: TStringField;
    ClUsuarioFoto: TBlobField;
    ClUsuarioVlr_Salario: TFloatField;
    ClUsuarioNr_matricula: TIntegerField;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button6Click(Sender: TObject);
    procedure cbSelecionaBDChange(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure mskCarregaNomesExit(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure LimpaControles;
    
    procedure DBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Usuario: TUsuario;

implementation

uses Biblioteca;


{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  Usuario                         := TUsuario.Create(bdConexaoXML);
  cbSelecionaBDChange(Self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(Usuario) then Usuario.Free;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Usuario.Nome := mskNome.Text;
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskNome.SetFocus;
    exit;
  end; 

  Usuario.DataNascimento := mskDataNascimento.Text;
  case Usuario.CodigoMensagem of
    CodMensagemCampoEmBranco:
    begin
      Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
      mskDataNascimento.SetFocus;
      exit;
    end;

    CodMensagemCampoInvalido:
    begin
      Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoInvalido, MB_OK + MB_ICONWARNING);
      mskDataNascimento.SetFocus;
      exit;
    end;
  end;

  Usuario.Endereco        := mskEndereco.Text;
 
  Usuario.Estado          := IntToStr(mskEstado.GetIndex);
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskEstado.SetFocus;
    exit;
  end;

  Usuario.Cidade          := IntToStr(mskCidade.GetIndex);
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskCidade.SetFocus;
    exit;
  end;


  Usuario.CEP        := mskCEP.Text;
  Usuario.Cargo      := IntToStr(mskCargo.GetIndex);
  Usuario.Setor      := mskSetor.Text;
  Usuario.Telefone   := mskTelefone.Text;

  Usuario.Salario    := mskSalario.Text;
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskSalario.SetFocus;
    exit;
  end;


  Usuario.Matricula          := mskMatricula.Text;
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskMatricula.SetFocus;
    exit;
  end;   


  Usuario.Persistir;

  Usuario.CarregaUsuarios(ClUsuario);
end;

procedure TForm1.cbSelecionaBDChange(Sender: TObject);
begin
  case cbSelecionaBD.ItemIndex of
    0: Usuario.SetDataBase(bdConexaoXML);
    1: Usuario.SetDataBase(bdConexaoDBISAM);
    2: Usuario.SetDataBase(bdConexaoFirebird);
  end;
  Self.LimpaControles;

  mskCarregaNomes.TextCustomCombo.Clear;
  mskCarregaNomes.TextCustomCombo := Usuario.CarregaNomes;

  mskCarregaNomesExit(Self);
  Usuario.CarregaUsuarios(ClUsuario);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Usuario.Nome := mskNome.Text;
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskNome.SetFocus;
    Exit;
  end;

  Usuario.Excluir;

  Usuario.CarregaUsuarios(ClUsuario);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Usuario.CarregaUsuarios(ClUsuario);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  mskCarregaNomes.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Usuario.Nome := mskNome.Text;
  if Usuario.CodigoMensagem = CodMensagemCampoEmBranco then
  begin
    Application.MessageBox(PChar(Usuario.Mensagem), ETituloCampoEmBranco, MB_OK + MB_ICONWARNING);
    mskNome.SetFocus;
    Exit;
  end;

  Usuario.SalvarFoto;
  Usuario.CarregaFoto(ClUsuario);
end;

procedure TForm1.mskCarregaNomesExit(Sender: TObject);
begin
  if (mskCarregaNomes.Text <> '') then
  begin
    Usuario.CarregaRegistrosDeUmNome(mskCarregaNomes.Text);
    mskNome.Text            := Usuario.Nome;
    mskDataNascimento.Text  := Usuario.DataNascimento;
    mskEndereco.Text        := Usuario.Endereco;
    mskEstado.Text          := Usuario.Estado;
    mskCidade.Text          := Usuario.Cidade;
    mskCEP.Text             := Usuario.CEP;
    mskCargo.Text           := Usuario.Cargo;
    mskSetor.Text           := Usuario.Setor;
    mskTelefone.Text        := Usuario.Telefone;
    mskSalario.Text         := Usuario.Salario;
    mskMatricula.Text       := Usuario.Matricula;
  end;
end;

procedure TForm1.DBGrid1CellClick(Column: TColumn);
begin
  mskCarregaNomes.Text := ClUsuarioNome.AsString;
  mskCarregaNomesExit(Self);
end;



procedure TForm1.DBGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = vk_delete) and (Shift = [ssCtrl]) then Abort;
end;

procedure TForm1.LimpaControles;
begin
  Biblioteca.ClearControls([mskNome, mskDataNascimento, mskEndereco, mskEstado, mskCidade, mskCEP, mskCargo,
  mskSetor, mskTelefone, mskSalario, mskMatricula]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Self.LimpaControles;
end;

end.

