unit UnPrincipal;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs,  Menus,  DBClient,
  ComCtrls,  MidasLib,  DBGrids, StdCtrls, DB, Grids, ExtCtrls,
  Buttons, UnClasses;

type
  TFrameForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    StatusBar1: TStatusBar;
    Panel4: TPanel;
    Panel3: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    Arrangeicons1: TMenuItem;
    Utilitrios1: TMenuItem;
    Calculadora1: TMenuItem;
    Sobre1: TMenuItem;
    SobreoPrograma1: TMenuItem;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    procedure Trata_Erros(Sender: TObject; E:Exception);
    procedure Exit1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrangeicons1Click(Sender: TObject);
    procedure Calculadora1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Conexao: TConexaoXML;
  end;

var
  FrameForm: TFrameForm;

implementation


{$R *.dfm}

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrameForm.Arrangeicons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TFrameForm.Calculadora1Click(Sender: TObject);
begin
  WinExec('calc.exe',SW_SHOWNORMAL)
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  Application.OnException:= Trata_Erros;
end;

procedure TFrameForm.Trata_Erros(Sender: TObject; E: Exception);
  var mens: string;
begin
    mens := '';

    if E is EInOutError then
    Mens := 'Erro de sistema. Tente novamente.' +#13+
    'Seno cancele a operao e contate ' +#13+
    'ao Suporte.'
    Else
    if E is EOutofMemory then
    Mens := 'Sem memria. Tente novamente.' +#13+
    'Seno cancele a operao e contate ' +#13+
    'ao Suporte.'
    Else
    if E is EConvertError then
    Mens := 'Erro na converso de dados.' +#13+
    'Persistindo esta operao favor entrar em contato com o Suporte.'
    Else
   // if E is EDBISAMEngineError then
   begin
     Mens := E.Message;
   // else if Mens = '' then Mens := E.Message ;

     Application.MessageBox(pchar(mens),'Erro',MB_OK+MB_ICONERROR);
   end;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  if Assigned(Conexao) then
  begin
    Conexao.FechaBanco; //fecha ltimo banco aberto
    Conexao.Free;
    Conexao := nil;
  end;   
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  Conexao := TConexaoXML.create('Usuarios.xml','Nome');
  Self.DataSource1.DataSet := Conexao.DataSet;
end;

end.
