unit unitSimulator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RXSwitch, StdCtrls, ExtCtrls, RXSlider, Spin, RxGIF, ComCtrls,
  Grids, DB, DBGrids, Buttons;

type
  TForm1 = class(TForm)
    SensorTime: TTimer;
    GroupBox4: TGroupBox;
    Panel2: TPanel;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    RadioButton1: TRadioButton;
    Panel5: TPanel;
    Panel1: TPanel;
    SW1: TPanel;
    SW2: TPanel;
    SW3: TPanel;
    procedure SistemaLigadoClick(Sender: TObject);

    procedure LeSensores;
    procedure SensorTimeTimer(Sender: TObject);
    Function  Int_To_Bin_Str(Primeiro_Byte: Byte): String;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
 Form1: TForm1;
 Sistema_Ligado: boolean = false;

Const
 Base     = $378; //Endereo base da porta LPT;
 Dados    = Base+0; //Endereo para escrita dos dados;
 Status   = Base+1; //Endereo para leitura dos dados;
 Controle = Base+2; //Endereo para escrita;
 DadosEPP = Base+4; //ou Base+0, l e escreve no modo EPP.

 BIT9 = $00; // 0000-0000
 BIT8 = $88; // 1000-1000
 BIT0 = $01; // 0000-0001
 BIT1 = $02; // 0000-0010
 BIT2 = $04; // 0000-0100
 BIT3 = $08; // 0000-1000
 BIT4 = $10; // 0001-0000
 BIT5 = $20; // 0010-0000
 BIT6 = $40; // 0100-0000
 BIT7 = $80; // 1000-0000

implementation

{$R *.dfm}

{Definio das funes da DLL.}
function inportb(EndPorta: Integer): BYTE stdcall; external 'inpout32.dll' name 'Inp32';
procedure outportb(EndPorta: Integer; Valor:BYTE); stdcall; external 'inpout32.dll' name 'Out32';

procedure TForm1.SistemaLigadoClick(Sender: TObject);
begin
 if Sistema_Ligado = false then
  Sistema_Ligado := true
 else
  Sistema_Ligado := False;

 if Sistema_Ligado then
  begin
   Panel2.Caption:= '1';
   Form1.Refresh;
   sleep(100);
   Panel2.Caption:= '2';
   Form1.Refresh;
   sleep(100);
   Panel2.Caption:= '3';
   Form1.Refresh;
   sleep(100);
   Panel2.Caption:= 'On';
   Form1.Refresh;

   GroupBox3.Enabled := true;
   GroupBox4.Enabled := true;
   SensorTime.Enabled := true;
  end
 else
  begin
   SW1.Color := clRed;
   SW2.Color := clRed;
   SW3.Color := clRed;
   SensorTime.Enabled := false;
   Panel2.Caption:= 'Off';
   GroupBox3.Enabled := false;
  end;
end;

Function TForm1.Int_To_Bin_Str(Primeiro_Byte: Byte): String;
var
 s: string;
begin
 Result := '';

 if Primeiro_Byte - 128 >= 0 then
  begin
   insert('1', result, 1);
   Primeiro_Byte := Primeiro_Byte - 128;


   SW1.Color := clRed;
   //SW1.StateOn := false;
  end
 else
  begin
   insert('0', result, 1);

   SW1.Color := clGreen;
   //SW1.StateOn := true;
  end;

 if Primeiro_Byte - 64 >= 0 then
  begin
   insert('1', result, 2);
   Primeiro_Byte := Primeiro_Byte - 64;

   SW2.Color := clGreen;
   //SW2.StateOn := true;
  end
 else
  begin
   insert('0', result, 2);
   SW2.Color := clRed;
   // SW2.StateOn := false;
  end;

 if Primeiro_Byte - 32 >= 0 then
  begin
   insert('1', result, 3);
   Primeiro_Byte := Primeiro_Byte - 32;
   SW3.Color := clGreen;
   //SW3.StateOn := true;
  end
 else
  begin
   insert('0', result, 3);
   SW3.Color := clRed;
   //SW3.StateOn := false;
  end;

 if Primeiro_Byte - 16 >= 0 then
  begin
   insert('1', result, 4);
   Primeiro_Byte := Primeiro_Byte - 16;

   SW2.Color := clGreen;
   //SW2.StateOn := true;
  end
 else
  begin
   insert('0', result, 4);

   SW2.Color := clRed;
   //SW2.StateOn := false;
  end;

 if Primeiro_Byte - 8 >= 0 then
  begin
   insert('1', result, 5);
   Primeiro_Byte := Primeiro_Byte - 8;
  end
 else
  begin
   insert('0', result, 5);
  end;

 if Primeiro_Byte - 4 >= 0 then
  begin
   insert('1', result, 6);
   Primeiro_Byte := Primeiro_Byte - 4;
  end
 else
  insert('0', result, 6);

 if Primeiro_Byte - 2 >= 0 then
  begin
   insert('1', result, 7);
   Primeiro_Byte := Primeiro_Byte - 2;
  end
 else
  insert('0', result, 7);

 if Primeiro_Byte - 1 >= 0 then
  begin
   insert('1', result, 8);
   Primeiro_Byte := Primeiro_Byte - 1;
  end
 else
  insert('0', result, 8);

end;

procedure TForm1.SensorTimeTimer(Sender: TObject);
begin
 //desabilite o timer para evitar re-entrncia durante o tratamento do dado
 SensorTime.enabled := false;

 //leitura e tratamento do dado lido
 LeSensores;

 //habilite o timer para novas leituras
 SensorTime.enabled := true;
end;

procedure TForm1.LeSensores;
var Teste : string;
begin
 Label2.Caption :=  Int_To_Bin_Str(inportb(Status));// 'Recebido(889): ' +
 RadioButton1.Checked := not RadioButton1.Checked;
end;

end.
